#include <stdio.h>
#include <stdint.h>
#include <assert.h>
#include <immintrin.h>

const uint64_t p1 = 9223372036854775837ULL; // 2**63 + 29
const uint64_t p2 = 18446744073709551557ULL; // 2**64 - 59

uint64_t rand63p29(void)
{
    uint64_t r;
#ifdef __DEBUG
    unsigned c = 0;
#endif

    do
    {
        do
        {
        } while (!_rdrand64_step(&r)); // relativement lent comme générateur unique ; ici pour simplifier
#ifdef __DEBUG
        if (c++ > 0)
        {
            fprintf(stderr, "%u\n", c);
        }
#endif
    } while (r >= p1);

    return r;
}


uint64_t rand64m59(void)
{
    uint64_t r;
#ifdef __DEBUG
    unsigned c = 0;
#endif

    do
    {
        do
        {
        } while (!_rdrand64_step(&r));
#ifdef __DEBUG
        if (c++ > 0)
        {
            fprintf(stderr, "%u\n", c);
        }
#endif
    } while (r >= p2);

    return r;
}

void testrun(uint64_t k)
{
    for (uint64_t i = 0; i < k; i++)
        printf("%llu\n", rand63p29());

    printf("\n");

    for (uint64_t i = 0; i < k; i++)
        printf("%llu\n", rand64m59());
}

int main()
{
    testrun(50);

    return 0;
}
